#!/bin/sh
#
#     Template SUSE system startup script for example service/daemon java.binfmt_misc
#     Copyright (C) 1995--2005  Kurt Garloff, SUSE / Novell Inc.
#          
#     This library is free software; you can redistribute it and/or modify it
#     under the terms of the GNU Lesser General Public License as published by
#     the Free Software Foundation; either version 2.1 of the License, or (at
#     your option) any later version.
#			      
#     This library is distributed in the hope that it will be useful, but
#     WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#      
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
#     USA.
#
# /etc/init.d/java.binfmt_misc
#   and its symbolic link
# /(usr/)sbin/rcjava.binfmt_misc
#
# Template system startup script for some example service/daemon java.binfmt_misc
#
# LSB compatible service control script; see http://www.linuxbase.org/spec/
# 
#
### BEGIN INIT INFO
# Provides:          java.binfmt_misc
# Required-Start:    $remote_fs
# Should-Start: 
# Required-Stop:     $remote_fs
# Should-Stop: 
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: enables the system to automatically execute java *.jar and *.class files
# Description:       Start java.binfmt_misc to allow the execution of java programs with *.class or *.jar extension
### END INIT INFO

# see #271198
java_binfmt_misc_status ()
{
    [ ! -e /proc/sys/fs/binfmt_misc/status ] && return 4
    [ `cat /proc/sys/fs/binfmt_misc/status` != "enabled" ] && return 3

    for state in Java ExecutableJAR JavaWebStart
    do
        if [ ! -e /proc/sys/fs/binfmt_misc/$state ]; then
            echo Warning /proc/sys/fs/binfmt_misc/$state is not present
            return 3
        fi

        if [ `head -n 1 /proc/sys/fs/binfmt_misc/$state` != "enabled" ]
        then
            echo Warning /proc/sys/fs/binfmt_misc/$state is not enabled
        fi
    done

    return 0
}


# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
for file in /usr/bin/javawrapper /usr/bin/jarwrapper /usr/bin/javaclassname
do
    test -x $file || { echo "$file not installed"; 
    if [ "$1" = "stop" ]; then exit 0;
    else exit 5; fi; }
done

# Check for existence of needed config file and read it
#java.binfmt_misc_CONFIG=/etc/sysconfig/java.binfmt_misc
#test -r $java.binfmt_misc_CONFIG || { echo "$java.binfmt_misc_CONFIG not existing";
#	if [ "$1" = "stop" ]; then exit 0;
#	else exit 6; fi; }

# Read config	
#. $java.binfmt_misc_CONFIG

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

case "$1" in
    start)
    echo -n "Starting java.binfmt_misc "

    # Insert BINFMT_MISC module into the kernel
    if [ ! -e /proc/sys/fs/binfmt_misc/register ]; then
        if [ -x /sbin/modprobe ]; then
            /sbin/modprobe binfmt_misc
            # Some distributions, like Fedora Core, perform
            # the following command automatically when the
            # binfmt_misc module is loaded into the kernel.
            # Thus, it is possible that the following line
            # is not needed at all. Look at /etc/modprobe.conf
            # to check whether this is applicable or not.
            if ! mount | grep -q binfmt
            then
                mount -t binfmt_misc none /proc/sys/fs/binfmt_misc 
            fi
        fi
    fi

    # Register support for class and jar files
    if [ -e /proc/sys/fs/binfmt_misc/register ]; then
        # support for Java applications:
        if [ -e /proc/sys/fs/binfmt_misc/Java ]
        then
            echo 1 > /proc/sys/fs/binfmt_misc/Java
        else
            echo ':Java:M::\xca\xfe\xba\xbe::/usr/bin/javawrapper:' > /proc/sys/fs/binfmt_misc/register
        fi
        # support for executable Jar files:
        if [ -e /proc/sys/fs/binfmt_misc/ExecutableJAR ]
        then
            echo 1 > /proc/sys/fs/binfmt_misc/ExecutableJAR
        else
            echo ':ExecutableJAR:E::jar::/usr/bin/jarwrapper:' > /proc/sys/fs/binfmt_misc/register
        fi
        # support for executable javaws
        if [ -e /proc/sys/fs/binfmt_misc/JavaWebStart ]
        then
            echo 1 > /proc/sys/fs/binfmt_misc/JavaWebStart
        else
            echo ':JavaWebStart:E::jnlp::/usr/bin/javawswrapper:' > /proc/sys/fs/binfmt_misc/register
        fi
        echo 1 > /proc/sys/fs/binfmt_misc/status
        ## support for Java Applets:
        #  ':Applet:E::html::/usr/bin/appletviewer:'
        ##or the following, if you want to be more selective:
        #  ':Applet:M::<!--applet::/usr/bin/appletviewer:'
    fi


    # Remember status and be verbose
    rc_status -v
    ;;
    stop)
    echo -n "Shutting down java.binfmt_misc "
    # Register support for class and jar files
    if [ -e /proc/sys/fs/binfmt_misc/register ]; then
        # support for Java applications:
        if [ -e /proc/sys/fs/binfmt_misc/Java ]; then
            echo -1 > /proc/sys/fs/binfmt_misc/Java
        fi
        # support for executable Jar files:
        if [ -e /proc/sys/fs/binfmt_misc/ExecutableJAR ]; then
            echo -1 > /proc/sys/fs/binfmt_misc/ExecutableJAR
        fi
        # support for javaws
        if [ -e /proc/sys/fs/binfmt_misc/JavaWebStart ]; then
            echo -1 > /proc/sys/fs/binfmt_misc/JavaWebStart
        fi
        ## support for Java Applets:
        #  ':Applet:E::html::/usr/bin/appletviewer:'
        ##or the following, if you want to be more selective:
        #  ':Applet:M::<!--applet::/usr/bin/appletviewer:'
    fi


    # Remember status and be verbose
    rc_status -v
    ;;
    try-restart|condrestart)
    ## Do a restart only if the service was active before.
    ## Note: try-restart is now part of LSB (as of 1.9).
    ## RH has a similar command named condrestart.
    if test "$1" = "condrestart"; then
        echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
    fi
    $0 status
    if test $? = 0; then
        $0 restart
    else
        rc_reset	# Not running is not a failure.
    fi
    # Remember status and be quiet
    rc_status
    ;;
    restart)
    ## Stop the service and regardless of whether it was
    ## running or not, start it again.
    $0 stop
    $0 start

    # Remember status and be quiet
    rc_status
    ;;

    reload)
    rc_failed 3
    ;;

    ## removed see #271198

    #    force-reload)
    #	## Signal the daemon to reload its config. Most daemons
    #	## do this on signal 1 (SIGHUP).
    #	## If it does not support it, restart the service if it
    #	## is running.
    #
    #	echo -n "Reload service java.binfmt_misc "
    #	## if it supports it:
    #	echo /sbin/killproc -HUP $java.binfmt_misc_BIN
    #	/sbin/killproc -HUP $java.binfmt_misc_BIN
    #	#touch /var/run/java.binfmt_misc.pid
    #	rc_status -v
    #
    #	## Otherwise:
    #	#$0 try-restart
    #	#rc_status
    #	;;
    #    reload)
    #	## Like force-reload, but if daemon does not support
    #	## signaling, do nothing (!)
    #
    #	# If it supports signaling:
    #	echo -n "Reload service java.binfmt_misc "
    #	/sbin/killproc -HUP $java.binfmt_misc_BIN
    #	#touch /var/run/java.binfmt_misc.pid
    #	rc_status -v
    #	
    #	## Otherwise if it does not support reload:
    #	#rc_failed 3
    #	#rc_status -v
    #	;;
    status)
    echo -n "Checking for service java.binfmt_misc "
    ## Check status with checkproc(8), if process is running
    ## checkproc will return with exit status 0.

    # Return value is slightly different for the status command:
    # 0 - service up and running
    # 1 - service dead, but /var/run/  pid  file exists
    # 2 - service dead, but /var/lock/ lock file exists
    # 3 - service not running (unused)
    # 4 - service status unknown :-(
    # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)

    # this function returns the LSB compliants status code
    # see #271198
    java_binfmt_misc_status
    # NOTE: rc_status knows that we called this init script with
    # "status" option and adapts its messages accordingly.
    rc_status -v
    ;;
    #    probe)
    #	## Optional: Probe for the necessity of a reload, print out the
    #	## argument to this init script which is required for a reload.
    #	## Note: probe is not (yet) part of LSB (as of 1.9)
    #
    #	test /etc/java.binfmt_misc/java.binfmt_misc.conf -nt /var/run/java.binfmt_misc.pid && echo reload
    #	;;
    *)
    echo "Usage: $0 {start|stop|status|try-restart|restart}"
    exit 1
    ;;
esac
rc_exit
